#include <iostream>
#include <string>
using namespace std;
// The description of the class:
class MyMoney{
public:
   string name;
   double money;
   double rate;
   int time;
   // The constructor without arguments:
   MyMoney(){
      name="";
      money=0;
      rate=0;
      time=0;
   }
   // The constructor with four arguments:
   MyMoney(string n,double m,double r,int t){
      setAll(n,m,r,t);
   }
   // The methods of the class:
   double getMoney(){
      double s=money;
         for(int k=1;k<=time;k++){
            s*=(1+rate/100);
         }
      return s;
   }
   void showAll(){
      cout<<"The name: "<<name<<endl;
      cout<<"The initial amount: "<<money<<endl;
      cout<<"The rate (%): "<<rate<<endl;
      cout<<"The term (in years): "<<time<<endl;
      cout<<"The final amount: "<<getMoney()<<endl;
      for(int k=1;k<=35;k++){
         cout<<"-";
      }
      cout<<endl;
   }
   void setAll(string n,double m,double r,int t){
      name=n;
      money=m;
      rate=r;
      time=t;
   }
   // The prefix form of the increment operator:
   MyMoney operator++(){
      money=money+1000;
      return *this;
   }
   // The postfix form of the increment operator:
   MyMoney operator++(int){
      time++;
      return *this;
   }
   // The operator method for calculating
   // the sum of two objects:
   MyMoney operator+(MyMoney obj){
      MyMoney tmp;
      tmp.name="Donald the Duck";
      tmp.money=money+obj.money;
      tmp.rate=(rate>obj.rate)?rate:obj.rate;
      tmp.time=(time+obj.time)/2;
      return tmp;
   }
};
// The operator function for subtracting objects:
double operator-(MyMoney objX,MyMoney objY){
   return objX.getMoney()-objY.getMoney();
}
// The prefix form of the decrement operator:
MyMoney operator--(MyMoney &obj){
   if(obj.money>1000){
      obj.money-=1000;
   }
   else{
      obj.money=0;
   }
   return obj;
}
// The postfix form of the decrement operator:
MyMoney operator--(MyMoney &obj,int){
   if(obj.time>0){
      obj.time--;
   }
   else{
      obj.time=0;
   }
   return obj;
}
// The main function of the program:
int main(){
   // Creates an object:
   MyMoney objA("Tom the Cat",1200,7,1);
   objA.showAll();
   // Decreases the field time:
   objA--;
   objA.showAll();
   // Decreases the field time:
   objA--;
   objA.showAll();
   // Increases the field time:
   objA++;
   objA.showAll();
   // Decreases the field money:
   --objA;
   objA.showAll();
   // Decreases the field money:
   --objA;
   objA.showAll();
   // Increases the field money:
   ++objA;
   objA.showAll();
   // Creates an object:
   MyMoney objB("Winnie the Bear",1100,8,5);
   objB.showAll();
   // Creates an object:
   MyMoney objC;
   // Calculates the sum of the objects:
   objC=objA+objB;
   objC.showAll();
   // Calculates the difference of the objects:
   cout<<"The difference of the objects:    "<<
objC-objB<<endl;
   return 0;
}