#include <iostream>
#include <string>
using namespace std;
// The description of the base class:
class MyMoney{
public:
   // The fields of the base class:
   string name;
   double money;
   double rate;
   int time;
   // The methods of the base class:
   double getMoney(){
      double s=money;
         for(int k=1;k<=time;k++){
            s*=(1+rate/100);
         }
      return s;
   }
   void showAll(){
      cout<<"The name: "<<name<<endl;
      cout<<"The initial amount: "<<money<<endl;
      cout<<"The rate (%): "<<rate<<endl;
      cout<<"The term (in years): "<<time<<endl;
      cout<<"The final amount: "<<getMoney()<<endl;
   }
   void setAll(string n,double m,double r,int t){
      name=n;
      money=m;
      rate=r;
      time=t;
   }
   // The constructor of the base class
   // (with four arguments):
   MyMoney(string n,double m,double r,int t){
      setAll(n,m,r,t);
   }
   // The constructor of the base class
   // (without arguments):
   MyMoney(){
      setAll("",0,0,0);
   }
};
// The derivative class:
class BigMoney: public MyMoney{
public:
   // The fields of the derivative class:
   int periods;
   // Overriding the methods:
   double getMoney(){
      double s=money;
         for(int k=1;k<=time*periods;k++){
            s*=(1+rate/100/periods);
         }
      return s;
   }
   void showAll(){
      cout<<"The name: "<<name<<endl;
      cout<<"The initial amount: "<<money<<endl;
      cout<<"The rate (%): "<<rate<<endl;
      cout<<"The term (in years): "<<time<<endl;
      cout<<"Charges per year: "<<periods<<endl;
      cout<<"The final amount: "<<getMoney()<<endl;
   }
   void setAll(string n,double m,double r,int t,int p){
      MyMoney::setAll(n,m,r,t);
      periods=p;
   }
   // The constructor of the derivative class
   // (with five arguments):
   BigMoney(string n,double m,double r,int t,int p=1):
   MyMoney(n,m,r,t){
      periods=p;
   }
   // The constructor of the derivative class
   // (without arguments):
   BigMoney(): MyMoney(){
      periods=1;
   }
};
// The main function of the program:
int main(){
   // Creates an object of the class MyMoney:
   MyMoney objA("Tom the Cat",1200,8,5);
   // Creates objects of the class BigMoney:
   BigMoney objB("Jerry the Mouse",1000,7,6,2);
   BigMoney objC("Winnie the Bear",1500,6,8);
   BigMoney objD;
   objD.setAll("Donald the Duck",800,10,3,4);
   // Checks the objects:
   objA.showAll();
   cout<<endl;
   objB.showAll();
   cout<<endl;
   objC.showAll();
   cout<<endl;
   objD.showAll();
   return 0;
}