#include <iostream>
#include <cmath>
using namespace std;
// The size of the array:
const int n=10;
// The class for the Taylor series implementation:
class Taylor{
public:
   // The field is an array:
   double a[n];
   // The constructor with a numerical argument:
   Taylor(double p=0){
      for(int k=0;k<n;k++){
         a[k]=p;
      }
   }
   // The constructor whose argument is a pointer:
   Taylor(double* b){
      for(int k=0;k<n;k++){
         a[k]=b[k];
      }
   }
   // The method calculates the series:
   double value(double x){
      double s=0,q=1;
      for(int k=0;k<n;k++){
         s+=a[k]*q;
         q*=x;
      }
      return s;
   }
};
// The main function of the program:
int main(){
   // The numerical array:
   double b[n]=
   {0,1,0,1./3,0,2./15,0,17./315,0,62./2835};
   // Creates objects:
   Taylor myexp,f(1),mytan(b);
   // Accesses the element of the array
   // which is a field of the object:
   myexp.a[0]=1;
   // Fills the array that is a field of the object:
   for(int k=1;k<n;k++){
      myexp.a[k]=myexp.a[k-1]/k;
   }
   // The argument for calculating
   // the function and series:
   double x=1.0;
   // Calculates the function and series:
   cout<<myexp.value(x)<<" vs. "<<exp(x)<<endl;
   cout<<mytan.value(x)<<" vs. "<<tan(x)<<endl;
   cout<<f.value(x/2)<<" vs. "<<1/(1-x/2)<<endl;
   return 0;
}