#include <iostream>
using namespace std;
// The description of the class:
class MyClass{
public:
   // The character field:
   char code;
   // The field is a pointer to an object:
   MyClass* next;
   // The copy constructor:
   MyClass(MyClass &obj){
      // Assigns a value to the field next of the
      // object that is passed to the constructor:
      obj.next=this;
      // Assigns a value to the field code
      // of the created object:
      code=obj.code+1;
   }
   // The constructor with a character argument:
   MyClass(char s){
      code=s;
   }
   // The destructor:
   ~MyClass(){
      if(next){ // If it is not the last object
         // Deletes the next object:
         delete next;
      }
      cout<<"The  object  with  the  field "<<code<<
      " is  deleted\n";
   }
   // The method prints the character field:
   void show(){
      // Prints the field:
      cout<<code<<" ";
      if(next){
         // Calls the method for the next object:
         next->show();
      }
   }
};
// The main function of the program:
int main(){
   // An integer variable:
   int n=10;
   // Creates a dynamic object:
   MyClass* pnt=new MyClass('A');
   // A pointer to an object:
   MyClass *p;
   // The initial value of the pointer:
   p=pnt;
   // Creates the chain of objects:
   for(int k=1;k<=n;k++){
      // Creates the next object:
      p=new MyClass(*p);
   }
   // Assigns the zero value to the field next
   // of the last object in the chain:
   p->next=0;
   // Calls the method for the first object
   // in the chain:
   pnt->show();
   cout<<endl;
   // Deletes the first object
   // (and all other objects) in the chain:
   delete pnt;
   return 0;
}