#include <iostream>
#include <string>
using namespace std;
// The template class:
template<class T> class MyClass{
private:
   // The private field:
   T value;
public:
   // The constructor:
   MyClass(T v){
      value=v;
   }
   // The method prints the field:
   void show(){
      cout<<"The field: "<<value<<endl;
   }
};
// The explicit specialization of the class:
template<> class MyClass<string>{
private:
   // The private field is an array:
   char value[100];
public:
   // The constructor:
   MyClass(char* str){
      int k;
      // The first character in the array:
      value[0]='|';
      // Fills the array:
      for(k=0;str[k];k++){
         value[2*k+1]=str[k];
         value[2*k+2]='|';
      }
      // Adds the null character at the end
      // of the array:
      value[2*k+1]='\0';
   }
   void show(){
      cout<<value<<endl;
   }
};
// The main function of the program:
int main(){
   MyClass<int> objA(100);
   // Creates objects based on the template class:
   MyClass<char> objB('A');
   MyClass<char*> objC((char*)"text");
   MyClass<string> objD((char*)"text");
   // Calls the method from the objects:
   objA.show();
   objB.show();
   objC.show();
   objD.show();
   return 0;
}