#include <iostream>
#include <string>
using namespace std;
// The first base template class:
template<class A> class Alpha{
public:
   // The field:
   A alpha;
   // The constructor:
   Alpha(A a){
      alpha=a;
   }
   // The method:
   void show(){
      cout<<"The field alpha: "<<alpha<<endl;
   }
};
// The second base template class:
template<class B> class Bravo{
public:
   // The field:
   B bravo;
   // The constructor:
   Bravo(B b){
      bravo=b;
   }
   // The method:
   void show(){
      cout<<"The field bravo: "<<bravo<<endl;
   }
};
// The derivative template class:
template<class A,class B,class C> class Charlie:
public Alpha<A>,public Bravo<B>{
public:
   // The field:
   C charlie;
   // The constructor:
   Charlie(A a,B b,C c):Alpha<A>(a),Bravo<B>(b){
      charlie=c;
   }
   // Overrides the method:
   void show(){
      // Calls the method from the first base class:
      Alpha<A>::show();
      // Calls the method from the second base class:
      Bravo<B>::show();
      cout<<"The field charlie: "<<charlie<<endl;
   }
};
// The main function of the program:
int main(){
   // Creates objects:
   Charlie<string,char,int> objA("text",'A',100);
   Charlie<int,double,char> objB(200,5.5,'B');
   // Calls the method from the objects:
   objA.show();
   objB.show();
   return 0;
}