#include <iostream>
#include <cmath>
#include <string>
using namespace std;
// The function for solving equations by the
// fixed-point iteration method:
double findRoot(double (*f)(double),double x0,int n){
   // The initial approximation for the equation root:
   double x=x0;
   // Makes iterations:
   for(int k=1;k<=n;k++){
      x=f(x);
   }
   // The result of the function:
   return x;
}
// The functions determine the equations:
double f(double x){
   return 0.5*cos(x);
}
double g(double x){
   return exp(-x);
}
double h(double x){
   return (x*x+6)/5;
}
// The function for solving equations
// and testing the roots:
void test(double (*f)(double),double x0,string eq){
   // The number of iterations:
   int n=100;
   // The variable to save the root of the equation:
   double z;
   cout<<"The root of the equation "<<eq<<":\t";
   // Finds the root of the equation:
   z=findRoot(f,x0,n);
   // Prints the result:
   cout<<z<<endl;
   cout<<"Testing the root:\t";
   // Tests the root:
   cout<<z<<" = "<<f(z)<<endl;
   for(int k=1;k<=50;k++){
      cout<<"-";
   }
   cout<<endl;
}
// The main function of the program:
int main(){
   // Solves the equations:
   test(f,0,"x=0.5cos(x)");
   test(g,0,"x=exp(-x)");
   test(h,1,"x=(x*x+6)/5");
   return 0;
}