#include <iostream>
using namespace std;
// The function for calculating the coefficients
// for the polynomial:
void findA(double* a,double* x,double* y,int n){
   // The variable to save the product:
   double q;
   // Calculates the coefficients
   // for the polynomial:
   for(int k=0;k<n;k++){
      // The initial value for the coefficient:
      a[k]=y[k];
      // The initial value for the product:
      q=1;
      // Calculates the coefficient:
      for(int m=0;m<k;m++){
         a[k]-=a[m]*q;
         q*=x[k]-x[m];
      }
      // The final value of the coefficient:
      a[k]/=q;
   }
}
// The function calculates the value
// of the Newton polynomial at the point:
double P(double* a,double z,double* x,int n){
   // The variable to save the result of the function:
   double s=0;
   // The local variable to save the product:
   double q=1;
   // Calculates the polynomial sum:
   for(int k=0;k<n;k++){
      // Adds the term to the polynomial sum:
      s+=a[k]*q;
      // Calculates the term for the next iteration:
      q*=z-x[k];
   }
   // The result of the function:
   return s;
}
// The function prints the "line":
void line(int m){
   for(int k=1;k<=m;k++){
      cout<<"-";
   }
   cout<<endl;
}
// The main function of the program:
int main(){
   // The index and the length of the "line":
   int k,m=20;
   // The size of the arrays:
   const int n=5;
   // The points:
   double x[n]={1,3,5,7,9};
   // The values of the function:
   double y[n]={0,2,-1,1,3};
   // The coefficients for the Newton polynomial:
   double a[n];
   // Calculates the coefficients:
   findA(a,x,y,n);
   line(m);
   cout<<"x\t| P(x)\n";
   line(m);
   // Prints the points and the values
   // of the interpolation polynomial:
   for(k=0;k<n;k++){
      cout<<x[k]<<"\t| "<<P(a,x[k],x,n)<<endl;
   }
   // The increment for the argument:
   double dx=1;
   line(m);
   cout<<"x\t| P(x)\n";
   line(m);
   // The value of the argument and
   // the value of the polynomial:
   for(k=0;k<n;k++){
      cout<<x[k]+dx<<"\t| "<<P(a,x[k]+dx,x,n)<<endl;
   }
   return 0;
}