#include <iostream>
#include <cmath>
using namespace std;
// The function for calculating integrals
// by Simpson's method:
double integrate(double (*f)(double),double a,
double b,
int m=1000){
   // The length of the subinterval:
   double h=(b-a)/2/m;
   // The variable for saving the integral sum:
   double s=0;
   // Calculates the integral sum:
   for(int k=1;k<=m-1;k++){
      s+=4*f(a+(2*k-1)*h)+2*f(a+2*k*h);
   }
   s+=f(a)+f(b)+4*f(a+(2*m-1)*h);
   s*=h/3;
   // The result of the function:
   return s;
}
// The integrand functions:
double F1(double x){
   return x*(1-x);
}
double F2(double x){
   double pi=3.141592;
   return pi/2*tan(pi*x/4);
}
double F3(double x){
   return exp(-x)*cos(x);
}
// The main function of the program:
int main(){
   cout<<"Calculation of integrals\n";
   cout<<integrate(F1,0,1)<<" vs. "<<
   (double)1/6<<endl;
   cout<<integrate(F2,0,1)<<" vs. "<<log(2)<<endl;
   cout<<integrate(F3,0,100,1e5)<<" vs. "<<0.5<<endl;
   return 0;
}